<template lang="pug">
  div(id="root")
    label ability check
    select(v-model="playerID")
      option(
        v-for="(item, index) in players"
        :key="index"
        :value="index")
        | {{ item.name }}
    select(v-model="abilityID")
      option(
        v-for="(item, index) in ability.list"
        :key="index"
        :value="index")
        | {{ item.label }}
    select(v-model="difficult")
      option(
        v-for="(item, index) in ability.checks"
        :key="index"
        :value="item.value")
        | {{ item.label }}
    button(
      @click="check")
      | Check
    div
      label Last d20
      input(disabled v-model="lastD20")
    div
      label Result
      input(disabled v-model="result")
</template>

<script>
import { mapGetters, mapState } from 'vuex'

export default {
  data () {
    return {
      playerID: null,
      abilityID: null,
      difficult: null,
      lastD20: null,
      result: null,
    }
  },
  computed: {
    ...mapState('character', [
      'ability',
      'players'
    ]),
    ...mapGetters('character', [
      'checkAbility'
    ])
  },
  methods: {
    check () {
      let d20 = this.d20()
      this.lastD20 = d20
      this.result =this.checkAbility({
        playerID: this.playerID,
        abilityID: this.abilityID,
        d20,
        value: this.difficult
      })
    },
    getRandomInteger (min, max) {
      return Math.round(Math.random() * (max - min) + min)
    },
    d20 () {
      return this.getRandomInteger(0, 20)
    }
  }
}
</script>

<style lang="sass" scoped>
#root
  display: flex
  flex-direction: column
  button
    justify-content: center !important
  & > *
    justify-content: space-between
    display: flex
</style>
